; $Id: hdf_modis__define.pro,v 1.1 2012/03/13 16:03:55 awalther Exp $
function hdf_modis::get_data, product ,hres = hres
  default,product,'COD'
  case (product) of
    'COD': modis_name = 'Cloud_Optical_Thickness'
	'CODU':modis_name=   'Cloud_Optical_Thickness_Uncertainty'
    'REF': modis_name = 'Cloud_Effective_Radius'
	'REFU':modis_name = 'Cloud_Effective_Radius_Uncertainty'
	'REF21': modis_name = 'Cloud_Effective_Radius'
	'REF37': modis_name = 'Cloud_Effective_Radius'
	'REF37U':modis_name = 'Cloud_Effective_Radius'
	'REF16': modis_name = 'Cloud_Effective_Radius'
	'CWP':modis_name = 'Cloud_Water_Path'
    'CTY': modis_name = 'Cloud_Phase_Infrared'
	 'CTYO': modis_name = 'Cloud_Phase_Optical_Properties'
	'CTP': modis_name = 'Cloud_Top_Pressure'
	'CTT': modis_name = 'Cloud_Top_Temperature'
	'CMB': modis_name = 'Cloud_Mask'
	'CMB1': modis_name = 'Cloud_Mask_1km'
    'LON': modis_name = 'Longitude'
    'LAT' :modis_name = 'Latitude'
	  'TIM' : modis_name = 'Scan_Start_Time' 
	  'SOL_A':modis_name = 'SolarAzimuth' 
	  'SAT_A':modis_name = 'SensorAzimuth' 
	  'SOL_Z':modis_name = 'SolarZenith' 
	  'SAT_Z':modis_name = 'SensorZenith' 
	  'SCT':modis_name = 'Scan_Start_Time' 
	  'CH1':modis_name = 'Scan_Start_Time' 
	  'BT31':modis_name = 'Scan_Start_Time' 
	  
    else: begin
    end
  endcase
  
  
  
   if product eq 'CH1' then   MODIS_LEVEL1B_READ,self.file,1, data,/reflectance,name='AQUA'
   if product eq 'BT31' then   MODIS_LEVEL1B_READ,self.file,31, data,/temperature,name='AQUA'
  
  if n_elements(data) gt 0 then return,data
  
  
  if self.coll6_flag eq 1 then begin
    case(product) of 
	  'REF16':modis_name = 'Cloud_Effective_Radius_16'
	  'REF16U': modis_name = 'Cloud_Effective_Radius_Uncertainty_16'
      'REF37': modis_name = 'Cloud_Effective_Radius_37'
	  'REF37U': modis_name = 'Cloud_Effective_Radius_Uncertainty_37' 
    else:
	endcase
  endif

scope = self.hdf_sd::get_sds_info(modis_name)
data_raw = self.hdf_sd::get_sds(modis_name)

add_offset = self.hdf_sd::get_sds_att(modis_name,'add_offset')
scale_factor = self.hdf_sd::get_sds_att(modis_name,'scale_factor')
_FillValue  = self.hdf_sd::get_sds_att(modis_name,'_FillValue')

  data = (data_raw-add_offset[0])*scale_factor[0]
  idx_fill = where(data_raw eq _FillValue[0],c_fill)
  if c_fill gt 0 then data[idx_fill] = -999.


IF product eq 'REF37' and self.coll6_flag eq 0 THEN BEGIN
  dummy = 'Cloud_Effective_Radius_Difference'
  data_raw_diff = self.hdf_sd::get_sds(dummy)
  
  add_offset = self.hdf_sd::get_sds_att(dummy,'add_offset')
  scale_factor = self.hdf_sd::get_sds_att(dummy,'scale_factor')
  _FillValue  = self.hdf_sd::get_sds_att(dummy,'_FillValue')
 
  data_diff = (data_raw_diff-add_offset[0])*scale_factor[0]
  data += data_diff[*,*,1] 
  if c_fill gt 0 then data[idx_fill] = -999.
ENDIF

IF product eq 'REF16' and self.coll6_flag eq 0 THEN BEGIN
  dummy = 'Cloud_Effective_Radius_Difference'
  data_raw_diff = self.hdf_sd::get_sds(dummy)

  add_offset = self.hdf_sd::get_sds_att(dummy,'add_offset')
  scale_factor = self.hdf_sd::get_sds_att(dummy,'scale_factor')
  _FillValue  = self.hdf_sd::get_sds_att(dummy,'_FillValue')
 
  data_diff = (data_raw_diff-add_offset[0])*scale_factor[0]
 
  data += data_diff[*,*,0] 
  if c_fill gt 0 then data[idx_fill] = -999.
ENDIF

if total(product EQ ['LON','LAT','TIM'] ) EQ 1 AND KEYWORD_set(hres) then begin
    dum = self.hdf_sd::get_sds('Cloud_Optical_Thickness')
    size_full =  size(dum,/DIM)
    data = congrid(data,size_full[0],size_full[1],/Inte)
endif 

IF product EQ 'CTY' and KEYWORD_set(hres) then begin
    dum = self.hdf_sd::get_sds('Cloud_Optical_Thickness')
    size_full =  size(dum,/DIM)
    data = congrid(data,size_full[0],size_full[1]) 
ENDIF

return,data
end


function hdf_modis::init,file

self.coll6_flag = 0
if strMatch(file,'*flo*') then self.coll6_flag =1

dum=self.hdf_sd::init(file)
self.file = file
return,1
end


pro hdf_modis__define
   void = { hdf_modis $
   , coll6_flag : 1B $
   , INHERITS hdf_sd $
   , file : '' $
      }
  
 end




