; Specify window size
nxpix=958L
nypix=720L

SETPLOT='Z'
;read,'setplot?',setplot

if setplot eq 'Z' then begin
;-------------------------------------------
set_plot,'Z'
device,set_resolution=[nxpix,nypix],z_buffer=0
win_nx=!d.x_size
win_ny=!d.y_size

;--------------------------------------------
; Insert the main script
;--------------------------------------------
endif
; set color table
;  loadct,45,file='color_ck.tbl'
  loadct,0
  !p.background=254.
  !p.color=255.

mcolor=byte(!p.color)
mcolor=fix(mcolor)
if mcolor eq 0 then mcolor=255
col1=mcolor
icmm1=mcolor-1
icmm2=mcolor-2
if setplot eq 'x' then begin
   lc=mcolor
   window,4,xsize=nxpix,ysize=nypix
   device,retain=2,decomposed=0
endif
lab_station=['SchillerParkIL','SheboyganSpaceportWI','ZionIL','Bayside','Chiwaukee','Kenosha','Kewaunee','Lake_Geneva','Manitowoc','Milwaukee_16th_St','Milwaukee_SER','Newport','Racine','Sheboygan_Haven','Sheboygan_KA']
lat_station=[ 41.965, 43.7456, 42.4676,43.181792, 42.504722,42.596, 44.44312, 42.5800009,44.138619,43.01667, 43.060975, 45.237, 42.778304, 43.81523, 43.679]
lon_station=[-87.876,-87.7087,-87.81, -87.900976,-87.8093, -87.886,-87.50524,-88.499046,-87.6161, -87.93333,-87.913504,-86.993,-87.796138,-87.79194,-87.716]
alt_station=[195.,185.,178.,185.,178.,184.,186.,269.,178.,188.,188.,183.,188.,192.,192.]
nstation=n_elements(lat_station)
;
; Open an HDF file and and get file ID
idir='/data/LMOS/CLAVRX/'
flname='clavrx_goes13_2012_136_0102.level2.hdf'
openr,1,'clavrx.fil'
nfiles=0l
readf,1,nfiles
for nf=0,nfiles-1 do begin
flname=''
readf,1,flname
result=str_sep(flname,'.')
label=result(0)
if setplot eq 'ps' then begin
psfl=label+'.cld_opt_dcomp.ps'
device,/color,bits=8,/landscape,$
 filename=psfl
endif
mcolor=255
icmm2=mcolor-2
print,'flname=',flname
year=float(strmid(flname,14,4))
jday=float(strmid(flname,19,3))
hour=float(strmid(flname,23,2))
minute=float(strmid(flname,25,2))
second=0.
jday=jday-1.+hour/24.+minute/(60.*24.)
jday0=julday(1,1,year,0,0,0)
caldat, jday0+jday, month, day, year, hour, minute, second
print,month,day,year,hour,minute,second
smn=strtrim(month,2)
sdy=strtrim(day,2)
syr=strtrim(year,2)
shr=strtrim(hour,2)
smin=strtrim(minute,2)
ssec=strtrim(second,2)
if month lt 10 then smn='0'+smn
if day lt 10 then sdy='0'+sdy
if hour lt 10 then shr='0'+shr
if minute lt 10 then smin='0'+smin
yyyymmddhhmm=syr+smn+sdy+'.'+shr+smin
print,idir+flname
;cth = read_hdf_ssec(idir+flname,'CTH',lon=lon,lat=lat)
;refl_0_65um = read_hdf_ssec(idir+flname,'refl_0_65um_nom',lon=lon,lat=lat)
;temp_3_75um = read_hdf_ssec(idir+flname,'temp_3_75um_nom',lon=lon,lat=lat)
;temp_6_7um = read_hdf_ssec(idir+flname,'temp_6_7um_nom',lon=lon,lat=lat)
temp_11_0um = read_hdf_ssec(idir+flname,'temp_11_0um_nom',lon=lon,lat=lat)
;temp_13_3um = read_hdf_ssec(idir+flname,'temp_13_3um_nom',lon=lon,lat=lat)
;cld_prob = read_hdf_ssec(idir+flname,'cloud_probability',lon=lon,lat=lat)
;cld_hght = read_hdf_ssec(idir+flname,'cld_height_acha',lon=lon,lat=lat)
;cld_pres = read_hdf_ssec(idir+flname,'cld_press_acha',lon=lon,lat=lat)
cld_mask = read_hdf_ssec(idir+flname,'cloud_mask',lon=lon,lat=lat)
cld_opt_dcomp = read_hdf_ssec(idir+flname,'cld_opd_dcomp',lon=lon,lat=lat)
cld_opt_acha = read_hdf_ssec(idir+flname,'cld_opd_acha',lon=lon,lat=lat)
help,cld_opt_dcomp,cld_opt_acha
help,temp_11_0um
cld_opt=-999.+0.*cld_opt_dcomp
dindex=where(CLD_OPT_DCOMP ne -999.)
aindex=where(CLD_OPT_ACHA ne -999.)
if aindex(0) ne -1 then cld_opt(aindex)=cld_opt_acha(aindex)
if dindex(0) ne -1 then cld_opt(dindex)=cld_opt_dcomp(dindex)
; END dealing with HDF
;loadct,39
loadct,0
!psym=0
set_viewport,.1,.9,.1,.9
map_set,/us,/continents,limit=[41.,-90,46,-85],/HIRES,$
title='CLAVR-X '+label+' Cld OPT ',color=0
polyfill,[-90,-90,-45,-45,-90],[41,46,46,41,41],color=0

!psym=3
;index=where(lon eq -999. or lat eq -999. or lon lt -95 or lon gt -85 or lat lt 30 or lat gt 40)
index=where(lon eq -999. or lat eq -999. or lon lt -90 or lon gt -85 or lat lt 41 or lat gt 46)

cld_opt(index)=-999.
print,max(cld_opt)
cindex=where(cld_mask le 2l)
cld_opt(cindex)=-999.
contour,cld_opt,lon,lat,level=10.*findgen(31)/30.,/cell_fill,c_color=icmm2*findgen(31)/30.,/overplot,$
min_val=-999.
;refl_0_65um(index)=-999.
;contour,refl_0_65um,lon,lat,level=100.*findgen(31)/30.,/cell_fill,c_color=icmm2*findgen(31)/30.,/overplot,$
;min_val=-999.
;temp_11_0um(index)=-999.
;contour,temp_11_0um,lon,lat,level=180.+140*findgen(31)/30.,/cell_fill,c_color=icmm2*findgen(31)/30.,/overplot,$
;min_val=-999.
;print,max(temp_11_0um)
;index=where(temp_11_0um gt 0.)
;print,min(temp_11_0um(index))
;index=where(lon ne -999. and lat ne -999. and refl_0_65um gt 0.)
;plots,lon(index),lat(index),color=255*refl_0_65um(index)/60.

!psym=0
map_set,/us,/continents,/noeras,limit=[41.,-90,46,-85],/HIRES,$
/grid,latdel=1,londel=1,label=1,color=0
colors=mcolor+[0B,0B,0B,0B]
       DrawCounties_white, 'co2000p020.shp', Statenames=['WI','MI','IL','IN']
;       DrawCounties, 'co2000p020.shp', Statenames=['ID','MT','WY','ND','SD','MN','IA','WI','IL'], $

          Colors=colors
!psym=4
!p.thick=2
oplot,lon_station(3:nstation-1),lat_station(3:nstation-1),color=icmm2
xyouts,lon_station(3:nstation-1),lat_station(3:nstation-1),lab_station(3:nstation-1),color=icmm2
!p.thick=1
; color bar
!p.charsize=1.
        !psym=0
level=10.*findgen(31)/30.
;level=100.*findgen(31)/30.
;level=180+140*findgen(31)/30.
        imin=min(level)
        imax=max(level)
        set_viewport,.1,.9,.09,.1
        !type=2^2+2^3+2^6
        plot,[imin,imax],[0,0],yrange=[0,10],xrange=[imin,imax],$
        xtitle='(COT)',/noeras,color=0
        ybox=[0,10,10,0,0]
        x2=imin
        dx=(imax-imin)/float(icmm2)
;loadct,39
loadct,0
        for j=0,icmm2-1 do begin
            xbox=[x2,x2,x2+dx,x2+dx,x2]
            polyfill,xbox,ybox,color=j
            x2=x2+dx
        endfor
if setplot eq 'ps' then device,/close
print,max(cld_opt),min(cld_opt)
if setplot eq 'Z' then begin
image=tvrd(0,0,win_nx,win_ny)
image_byt=bytscl(image,min=0,max=255)
;transparent=bytarr(256)+255B
;transparent(255:255)=0
tvlct,r,g,b,/get

write_png,label+'.cld_opt_dcomp.png',image_byt,r,g,b
endif
endfor
end
