; $Id: read_hdf_ssec.pro,v 1.1 2012/03/13 16:03:56 awalther Exp $
;+
;
; :Author: awalther
;   combines geocat and clavrx tools
;-


FUNCTION read_hdf_ssec , file ,var $
       , lon = lon $
       , lat = lat $
	   , time = time $
       , start = start $
       , count = count $
	   , sensor = sensor $
	   , verbose = verbose $
       , remove_temp = remove_temp $
       , first = first $
	   , _extra = _extra
	   

ON_ERROR,2
; geocat
 
DEFAULT,sensor,'geocat'

; determine sensor from file name

IF strMatch(file,'*Meteosat*') then sensor = 'geocat'
IF strMatch(file,'NSS*') then sensor = 'clavrx'
IF strMatch(file,'patmos*') then sensor = 'clavrx'
IF strMatch(file,'*goes*') then sensor = 'clavrx'
IF strMatch(file,'*level2*') then sensor = 'clavrx'
IF strMatch(file,'*MYDATML2*') then sensor = 'modis'
IF strMatch(file,'*MODATML2*') then sensor = 'modis'
IF strMatch(file,'*MYD02SSH*') then sensor = 'modis'
IF strMatch(file,'*MOD02SSH*') then sensor = 'modis'
IF strMatch(file,'*MYD06*') then sensor = 'modis'
IF strMatch(file,'*MOD06*') then sensor = 'modis'
if strMatch(file,'*level2*') then sensor ='clavrx'

IF StrUpCase(sensor) eq 'MODIS' THEN BEGIN
    if keyword_set(verbose) then print,file
   oModis = hdf_modis(file)
   data = oModis.get_data(var)
;   IF ARG_PRESENT(lat) then lat = oModis.get_data('LAT',/hres)
;   IF ARG_PRESENT(lon) then lon = oModis.get_data('LON',/hres)
   IF ARG_PRESENT(lat) then lat = oModis.get_data('LAT')
   IF ARG_PRESENT(lon) then lon = oModis.get_data('LON')
   
  obj_destroy,oModis
  return,data

ENDIF


IF strMid(file,2,3,/re) eq '.gz' THEN BEGIN
  temp_file = '/tmp/read_hdf_ssec_temp_file.dat'
  IF keyword_set(first) THEN spawn,'rm -f '+temp_file
  spawn,'gunzip -cf ' + file +' > '+temp_file , good_news, bad_news
  
  IF bad_news[0] NE '' OR N_ELEMENTS(bad_news) GT 1 THEN BEGIN
    PRINT,'error gunzip  -- return , -1'
    RETURN,-1
  ENDIF
  file = temp_file
ENDIF

IF keyword_set(remove_temp) THEN file_delete,temp_file,/allow_no

IF FILE_TEST(file) EQ 0 THEN BEGIN
  MESSAGE,'File not existing',/INFO
  RETURN,-1
ENDIF

error = ''
catch,error
IF error ne '' then begin
  message,'hdf file wrong',/info
  return,-1
ENDIF

FileID = HDF_SD_START(file, /READ)
HDF_SD_FILEINFO, FileID, datasets , attributes

catch,/cancel

hdf_var = 'not yet found'
FOR j = 0, datasets -1 DO BEGIN

  thisSDS = HDF_SD_SELECT(FileID, j)
  HDF_SD_GETINFO, thisSDS, NAME=thisSDSName
  
  case strUpCase(var) OF 
  
    'CMA': BEGIN
	  IF strMatch(thisSDSName,'*cloud_mask*') then  hdf_var = thisSDSName
	END
	
	'CA': BEGIN
	  IF strMatch(thisSDSName,'*cloud_probability*') then hdf_var = thisSDSName
	END
	
    'LAT': BEGIN
	   IF strMatch(thisSDSName,'*latitude*') then  hdf_var = thisSDSName
	END
	
    'LON': BEGIN
	   IF strMatch(thisSDSName,'*longitude*') then  hdf_var = thisSDSName
	END
	
	'AZI' : BEGIN
	  IF strMatch(thisSDSName,'*relative_a*') then  hdf_var = thisSDSName
	
	END
	
	 'SUN': BEGIN
	   IF strMatch(thisSDSName,'*solar*') then  hdf_var = thisSDSName
	END
	 'OBS': BEGIN
	   IF strMatch(thisSDSName,'*satellite_zenith*') then  hdf_var = thisSDSName
	   IF strMatch(thisSDSName,'*sensor_zenith*') then  hdf_var = thisSDSName
	END
	
	'COD' : BEGIN
	  IF strMatch(thisSDSName,'*day_cloud_optical_depth*') then  hdf_var = thisSDSName
	  IF strMatch(thisSDSName,'*cld_opd*') then  hdf_var = thisSDSName
	  IF strMatch(thisSDSName,'DCOMP*cloud_optical_depth*') then hdf_var = thisSDSName
	END
	
	'CODU': begin
	  IF strMatch(thisSDSName,'*cld_opd_dcomp_unc*') then  hdf_var = thisSDSName
	  
	  
	  end
	  
	  'REFU': begin
	  IF strMatch(thisSDSName,'*ref*unc*') then  hdf_var = thisSDSName
	  end
	  
	  
	'COD39': BEGIN
	  IF strMatch(thisSDSName,'*39_cloud_optical_depth*') then  hdf_var = thisSDSName
	  
	END
	
	'AZI':BEGIN
	
	  IF strMatch(thisSDSName,'*azimuth*') then  hdf_var = thisSDSName
	END
	
	'COT' : BEGIN
	  IF strMatch(thisSDSName,'*day_cloud_optical_depth*') then  hdf_var = thisSDSName
	  IF strMatch(thisSDSName,'*cld_opd*') then  hdf_var = thisSDSName
	END
	
	'COD_LM' : BEGIN
	  IF strMatch(thisSDSName,'*lm_cloud_optical_depth*') then  hdf_var = thisSDSName
	  IF strMatch(thisSDSName,'*opd*') then  hdf_var = thisSDSName
	END
	
	'COD_QF': BEGIN
	IF strMatch(thisSDSName,'*cld_opd_dcomp_qf*') then  hdf_var = thisSDSName
	
	END
	
	'REF_QF': BEGIN
	IF strMatch(thisSDSName,'*cld_reff_dcomp_qf*') then  hdf_var = thisSDSName
	
	END
	
  
   'CPH' : BEGIN
	  IF strMatch(thisSDSName,'*cloud_phase*') then  hdf_var = thisSDSName
	 
	END
	
	'CTY' : BEGIN
	   IF strMatch(thisSDSName,'*cloud_type*') then  hdf_var = thisSDSName
	END
	
	'REF' : BEGIN
	  IF strMatch(thisSDSName,'*day_cloud_particle_effective_radius*') then  hdf_var = thisSDSName
	  IF strMatch(thisSDSName,'*reff*') then  hdf_var = thisSDSName
	END
	
	'REF39' : BEGIN
	  IF strMatch(thisSDSName,'*39_cloud_particle_effective_radius*') then  hdf_var = thisSDSName
	  
	END
	
	'REF16': BEGIN
	
	  IF strMatch(thisSDSName,'*DCOMP_mode_1_cloud_particle_effective*') then  hdf_var = thisSDSName
	
	END
	
	'REF_LM' : BEGIN
	  IF strMatch(thisSDSName,'*lm_cloud_particle_effective_radius*') then  hdf_var = thisSDSName
	  IF strMatch(thisSDSName,'*reff*') then  hdf_var = thisSDSName
	END
	
	'CRE':BEGIN
	  IF strMatch(thisSDSName,'*reff*') THEN hdf_var = thisSDSName
	
	END
	
	'QCL' : BEGIN
	  IF strMatch(thisSDSName,'*lm_quality*') then  hdf_var = thisSDSName
	  
	END
	
	;'QC' : BEGIN
	  ;IF strMatch(thisSDSName,'*day_quality*') then  hdf_var = thisSDSName
	  
	;END
	
	'CTH' : BEGIN
	  IF strMatch(thisSDSName,'cld_height_acha') then  hdf_var = thisSDSName
	  
	END
	
	'CTT' : BEGIN
	  IF strMatch(thisSDSName,'cld_temp_acha') then  hdf_var = thisSDSName
	END
	'CT':BEGIN
	  IF strMatch(thisSDSName,'cld_temp_acha') then hdf_var = thisSDSName
	END
	
	'CTP' : BEGIN
	  IF strMatch(thisSDSName,'*pressure*') then  hdf_var = thisSDSName
	  IF strMatch(thisSDSName,'*press_sw*') then hdf_var = thisSDSName
	  IF strMatch(thisSDSName,'cld_press_acha') then hdf_var = thisSDSName
	;  print,hdf_var+' kk'
	END
	
	'CP':BEGIN
	   IF strMatch(thisSDSName,'*press_sw*') then hdf_var = thisSDSName
	 ; print,hdf_var,'ll'
	END
	
	'CPB' : BEGIN
	   IF strMatch(thisSDSName,'*probability*') then  hdf_var = thisSDSName
	END
	
	'NDVI' : BEGIN
	   IF strMatch(thisSDSName,'*ndvi*') then  hdf_var = thisSDSName
	END
	
	'LSM' : BEGIN
	   IF strMatch(thisSDSName,'*land_cover*') then  hdf_var = thisSDSName
	END

	
	'TRN': BEGIN
	  IF strMatch(thisSDSName,'*transmittance*') then hdf_var = thisSDSName
	  IF strMatch(thisSDSName,'*cloud_transmission*') then hdf_var = thisSDSName
	END
	
	'CAB': BEGIN
	  IF strMatch(thisSDSName,'*cloud_albedo*') then hdf_var = thisSDSName
	END
	
   'CTN': BEGIN
	  IF strMatch(thisSDSName,'*cloud_transmi*') then hdf_var = thisSDSName
	END
	
	'ATC1':BEGIN
	   IF strMatch(thisSDSName,'*atm_corr_vis*') then hdf_var = thisSDSName
	END
	
	'ATC2':BEGIN
	   IF strMatch(thisSDSName,'*atm_corr_ir*') then hdf_var = thisSDSName
	END
	
	'CH1':BEGIN
	   IF strMatch(thisSDSName,'*ch1_reflectance*') then hdf_var = thisSDSName
	   IF strMatch(thisSDSName,'refl_0_65um_nom') then hdf_var = thisSDSName
	END
	
	'CH2':BEGIN
	   IF strMatch(thisSDSName,'*ch2_reflectance*') then hdf_var = thisSDSName
	   IF strMatch(thisSDSName,'*channel_2_reflectance*') then hdf_var = thisSDSName
	   IF strMatch(thisSDSName,'refl_0_86um_nom') then hdf_var = thisSDSName
	END
	
	'CH3':BEGIN
	   IF strMatch(thisSDSName,'*ch3_reflectance*') then hdf_var = thisSDSName
	   IF strMatch(thisSDSName,'*channel_3_reflectance*') then hdf_var = thisSDSName
	END
	
	'CH31':BEGIN
	   IF strMatch(thisSDSName,'temp_11_0um_nom') then hdf_var = thisSDSName
	END
	
	'VIS':BEGIN
	  IF strMatch(thisSDSName,'*channel_2_reflectance*') then hdf_var = thisSDSName
	END
	'RFL16':BEGIN
	  IF strMatch(thisSDSName,'*refl_1_60um_nom*') then hdf_var = thisSDSName
	END
	
	'NIR':BEGIN
	  IF strMatch(thisSDSName,'*channel_5_reflectance*') then hdf_var = thisSDSName
	END
	
	'CTY':BEGIN
	  IF strMatch(thisSDSName,'*type*') then hdf_var = thisSDSName
	END
	
	'LCO':BEGIN
	  IF strMatch(thisSDSName,'*packed_land_cover*') then hdf_var = thisSDSName
	END
	
	'CEM':BEGIN
	  IF strMatch(thisSDSName,'*cld_emiss_sw*') then hdf_var = thisSDSName
	END
	
	'CBE':BEGIN
	  IF strMatch(thisSDSName,'*cld_beta_sw*') then hdf_var = thisSDSName
	END
	
	'EMIS_TROP':BEGIN
	  IF strMatch(thisSDSName,'*emissivity_11um_tropopause*') then hdf_var = thisSDSName
	END
	
	'AOT_CH1':BEGIN
	  IF strMatch(thisSDSName,'*aot_ch1*') then hdf_var = thisSDSName
	END
	
	'QF1':BEGIN
	  IF strMatch(thisSDSName,'*quality_flags_1*') then hdf_var = thisSDSName
	END
	
	'QF2':BEGIN
	  IF strMatch(thisSDSName,'*quality_flags_2*') then hdf_var = thisSDSName
	END
	
	'RFL_CH1':BEGIN
	  IF strMatch(thisSDSName,'*refl_0_65um_nom*') then hdf_var = thisSDSName
	END
	
	'RFL_CH2':BEGIN
	  IF strMatch(thisSDSName,'*ch2_reflectance*') then hdf_var = thisSDSName
	  IF strMatch(thisSDSName,'*refl_3_75um_nom*') then hdf_var = thisSDSName
	END
	
	'TMP_CH3B-CH4':BEGIN
	  IF strMatch(thisSDSName,'*ch3b-ch4_temp*') then hdf_var = thisSDSName
	END
	
	'TMP_CH4':BEGIN
	  IF strMatch(thisSDSName,'*ch4_temp*') then hdf_var = thisSDSName
	END
	
	'TMP_CH4-CH5':BEGIN
	  IF strMatch(thisSDSName,'*ch4-ch5_temp*') then hdf_var = thisSDSName
	END
	
	'BT4_STD':BEGIN
	  IF strMatch(thisSDSName,'*bt4_std_3x3*') then hdf_var = thisSDSName
	END
	
	'NDVI':BEGIN
	  IF strMatch(thisSDSName,'*ndvi*') then hdf_var = thisSDSName
	END
	
	'TMP_SFC':BEGIN
	  IF strMatch(thisSDSName,'*surface_temperature*') then hdf_var = thisSDSName
	END
	
	'RS_RFL':BEGIN
	  IF strMatch(thisSDSName,'*remote_sensing_reflectance*') then hdf_var = thisSDSName
	END
	
	'OLR':BEGIN
	  IF strMatch(thisSDSName,'*olr*') then hdf_var = thisSDSName
	END
	'EMS':BEGIN
	  IF strMatch(thisSDSName,'*cld_emiss_acha*') then hdf_var = thisSDSName
	END
	
	'VIS006': BEGIN
	  IF strMatch(thisSDSName,'channel_2_reflectance') then hdf_var = thisSDSName
      IF strMatch(thisSDSName,'*refl_0_65um_nom*') then hdf_var = thisSDSName
	END	  
	
	'WV06' : BEGIN
	  IF strMatch(thisSDSName,'*temp_6_7um_nom*') then hdf_var = thisSDSName
	END
	 
   'IR016': hdf_var = 'channel_5_reflectance'
   'PST': hdf_var = 'pixel_surface_type'
   
   'TIME': hdf_var = 'scan_line_time'
   'TSFC': hdf_var = 'surface_temperature_retrieved'
	
	ELSE: BEGIN
	    hdf_var = var
	END
	
  ENDCASE
  IF hdf_var ne 'not yet found' then break
ENDFOR

IF keyword_set(verbose) THEN PRINT,'  hdf variable is ',hdf_var



; read the data   
IF sensor EQ 'geocat' THEN BEGIN   
  offset = 1
  scale  = 1

  IF (N_Elements(start) EQ  2) AND (N_Elements(count) EQ 2) THEN read_all=0 ELSE read_all=1


    data = read_geocat(file, hdf_var) 
	
  if n_elements(data) eq 1 and data[0] eq -1 then begin
    print,'no data  -- return , -1'
    return,-1
  endif
  if strmid(var,0,3) eq 'QUA' then data = reform(data[0,*,*])
  

  IF ARG_PRESENT(lat) THEN BEGIN
  
    lat = read_hdf_ssec(file,'lat')
	
  ENDIF
  
  IF ARG_PRESENT(lon) NE 0 THEN BEGIN
    lon = read_hdf_ssec(file,'lon')
  ENDIF
  
  
ENDIF ELSE BEGIN

  ; clavrx/patmosx sensor
;    data = read_clavrx_hdf(file,hdf_var, error_msg = error , /quiet)
    data = read_standard_hdf(file,hdf_var,  /quiet)
 
  IF ARG_PRESENT(lat) THEN BEGIN
   
	hdf_var_lat = 'latitude'	
;    lat = read_clavrx_hdf(file,hdf_var_lat,/quiet , error_msg = error)
    lat = read_standard_hdf(file,hdf_var_lat,/quiet)
	if size(lat,/n_dim) eq 1 then begin
	 
	   hdf_var_lon = 'longitude'
;       lon_dum = read_clavrx_hdf(file,hdf_var_lon,/quiet , error_msg = error)
       lon_dum = read_clavrx_hdf(file,hdf_var_lon,/quiet)
	   lat = lat ## make_array(n_elements(lon_dum),value=1.)
	
	endif
  ENDIF
  
  IF ARG_PRESENT(lon) THEN BEGIN
    hdf_var_lon = 'longitude'
;    lon = read_clavrx_hdf(file,hdf_var_lon,/quiet , error_msg = error)
    lon = read_standard_hdf(file,hdf_var_lon,/quiet)
	if size(lon,/n_dim) eq 1 then begin
	  hdf_var_lat = 'latitude'	
;      lat_dum = read_clavrx_hdf(file,hdf_var_lat,/quiet , error_msg = error)
      lat_dum = read_standard_hdf(file,hdf_var_lat,/quiet)
	  lon = lon # make_array(n_elements(lat_dum),value=1.)
	endif   
  ENDIF
  
  IF ARG_PRESENT(time) THEN BEGIN
    hdf_var_time = 'scan_line_time'
;	time = read_clavrx_hdf(file,hdf_var_time,/quiet, error_msg = error)
        time = read_standard_hdf(file,hdf_var_time,/quiet)
	
  
  
  
  ENDIF

ENDELSE   
   



HDF_SD_END,FileID


return,data















end
